###
### Generated by QuakeC -> Python translator
### Id: qc2python.py,v 1.5 2001/02/05 21:15:44 barryp Exp 
###
from qwpython.qwsv import engine, Vector
from qwpython.qcsupport import qc

import defs

#  Spectator functions
#  Added Aug11'97 by Zoid <zoid@idsoftware.com>
# 
#  These functions are called from the server if they exist.
#  Note that Spectators only have one think since they movement code doesn't
#  track them much.  Impulse commands work as usual, but don't call
#  the regular ImpulseCommand handler in weapons.qc since Spectators don't
#  have any weapons and things can explode.
# 
#    --- Zoid.
# 
# ===========
# SpectatorConnect
# 
# called when a spectator connects to a server
# ============
# 

def SpectatorConnect(*qwp_extra):
    engine.bprint(defs.PRINT_MEDIUM, 'Spectator ')
    engine.bprint(defs.PRINT_MEDIUM, qc.self.netname)
    engine.bprint(defs.PRINT_MEDIUM, ' entered the game\012')
    qc.self.goalentity = qc.world #  used for impulse 1 below
    
# 
# ===========
# SpectatorDisconnect
# 
# called when a spectator disconnects from a server
# ============
# 

def SpectatorDisconnect(*qwp_extra):
    engine.bprint(defs.PRINT_MEDIUM, 'Spectator ')
    engine.bprint(defs.PRINT_MEDIUM, qc.self.netname)
    engine.bprint(defs.PRINT_MEDIUM, ' left the game\012')
    
# 
# ================
# SpectatorImpulseCommand
# 
# Called by SpectatorThink if the spectator entered an impulse
# ================
# 

def SpectatorImpulseCommand(*qwp_extra):
    if qc.self.impulse == 1:
        #  teleport the spectator to the next spawn point
        #  note that if the spectator is tracking, this doesn't do
        #  much
        qc.self.goalentity = qc.find(qc.self.goalentity, 'classname', 'info_player_deathmatch')
        if qc.self.goalentity == qc.world:
            qc.self.goalentity = qc.find(qc.self.goalentity, 'classname', 'info_player_deathmatch')
        if qc.self.goalentity != qc.world:
            qc.setorigin(qc.self, qc.self.goalentity.origin)
            qc.self.angles = qc.self.goalentity.angles
            qc.self.fixangle = defs.TRUE #  turn this way immediately
            
        
    qc.self.impulse = 0
    
# 
# ================
# SpectatorThink
# 
# Called every frame after physics are run
# ================
# 

def SpectatorThink(*qwp_extra):
    #  self.origin, etc contains spectator position, so you could
    #  do some neat stuff here
    if qc.self.impulse:
        SpectatorImpulseCommand()
    
